import QtQuick 1.1

Item {
    id: maincomponent
    height: 22
    width: 30

    property bool isSelected: false
    property alias icon: selectionPanelIcon.source
    property alias iconVisible: selectionPanelIcon.visible
    property alias text: selectionPanelTitle.text
    property alias textVisible: selectionPanelTitle.visible
    property alias backgroundColor: selectionPanelTab.color

    signal triggered();

    Rectangle {
        id: selectionPanelTab
        anchors.fill: parent
        color: "transparent"

        Item {
            id: selectionPanelContent
            width: {
                var calc = 0;
                if (selectionPanelIcon.visible) calc += selectionPanelIcon.width
                if (selectionPanelTitle.visible) calc += selectionPanelTitle.width
                if (selectionPanelIcon.visible && selectionPanelTitle.visible) calc += 10
                return calc;
            }
            anchors.left: parent.left
            anchors.leftMargin: (parent.width - width) / 2
            anchors.top: parent.top
            anchors.bottom: parent.bottom

            Image {
                id: selectionPanelIcon
                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: -2
                anchors.left: parent.left

                fillMode: Image.PreserveAspectFit
                smooth: true

                visible: (sourceSize.width > 0)
            }

            Text {
                id: selectionPanelTitle
                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: -1
                anchors.left: parent.left
                anchors.leftMargin: (selectionPanelIcon.visible) ? selectionPanelIcon.width + 10 : 0

                smooth: true
            }

        }

        MouseArea {
            anchors.fill: parent
            onPressed: triggered();
        }
    }
}
