import Qt 4.7

Item {
    id: xaqmlFolderStatusPicker
    width: 250
    height: 364

    property bool enabled: true

    property string folderTrafficLightString : ""
    property int repeaterTrafficLightSegmentSelected

    property string folderActivityString : ""
    property int repeaterActivitySegmentSelected

    signal folderTrafficLightStringResultUpdated()
    signal folderActivityStringResultUpdated()

    onFolderTrafficLightStringChanged: {
//        console.debug("onFolderTrafficLightStringChanged")
//        console.debug(folderTrafficLightString)

        // 0 = Green
        // 1 = Yellow
        // 2 = Red

        if (folderTrafficLightString.charAt(0) == "1") repeaterTrafficLightSegmentSelected = 1;
        else if (folderTrafficLightString.charAt(0) == "2") repeaterTrafficLightSegmentSelected = 2;
        else repeaterTrafficLightSegmentSelected = 0;

        segmentTrafficLightGrid.currentIndex = repeaterTrafficLightSegmentSelected
    }

    onFolderActivityStringChanged: {
//        console.debug("onFolderActivityStringChanged")
//        console.debug(folderActivityString)

        // 0 = Active
        // 1 = On Hold
        // 2 = Cancelled
        // 3 = Completed

        if (folderActivityString.charAt(0) == "1") repeaterActivitySegmentSelected = 1;
        else if (folderActivityString.charAt(0) == "2") repeaterActivitySegmentSelected = 2;
        else if (folderActivityString.charAt(0) == "3") repeaterActivitySegmentSelected = 3;
        else repeaterActivitySegmentSelected = 0;

        segmentActivityGrid.currentIndex = repeaterActivitySegmentSelected
    }


    function updateFolderTrafficLightString() {
//        console.debug("updateFolderTrafficLightString")
//        console.debug(repeaterTrafficLightSegmentSelected)

        if (repeaterTrafficLightSegmentSelected == 1) folderTrafficLightString = "1";
        else if (repeaterTrafficLightSegmentSelected == 2) folderTrafficLightString = "2";
        else folderTrafficLightString = "0";

//        console.debug(folderTrafficLightString)
        folderTrafficLightStringResultUpdated()
    }

    function updateFolderActivityString() {
//        console.debug("updateFolderActivityString")
//        console.debug(repeaterActivitySegmentSelected)

        if (repeaterActivitySegmentSelected == 1) folderActivityString = "1";
        else if (repeaterActivitySegmentSelected == 2) folderActivityString = "2";
        else if (repeaterActivitySegmentSelected == 3) folderActivityString = "3";
        else folderActivityString = "0";

//        console.debug(folderActivityString)
        folderActivityStringResultUpdated()
    }

    ListModel {
        id: segmentTrafficLightModel

        ListElement {
            name: "Green"
            checked: "1"
        }
        ListElement {
            name: "Yellow"
            checked: "0"
        }
        ListElement {
            name: "Red"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Green"),
                            qsTr("Yellow"),
                            qsTr("Red")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: segmentActivityModel

        ListElement {
            name: "Active"
            checked: "1"
        }
        ListElement {
            name: "On Hold"
            checked: "0"
        }
        ListElement {
            name: "Cancelled"
            checked: "0"
        }
        ListElement {
            name: "Completed"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Active"),
                            qsTr("On Hold"),
                            qsTr("Cancelled"),
                            qsTr("Completed")
                        ]
            }
            return i18n.text[index]
        }
    }


    //
    // traffic light segment control
    //

    Item {
        id: repeatSegmentTrafficLightControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: "Traffic Light"
        }

        Rectangle {
            id: repeatSegmentTrafficLightControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentTrafficLightGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentTrafficLightModel
                delegate: segmentTrafficLightCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true

                onVisibleChanged: {
                    if (visible) {
                        segmentTrafficLightGrid.currentIndex = repeaterTrafficLightSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")

                    if (segmentTrafficLightGrid.currentIndex == 0) iconTrafficLightPreviewImage.source = "pics/FolderTrafficLightGreen80.png"
                    else if (segmentTrafficLightGrid.currentIndex == 1) iconTrafficLightPreviewImage.source = "pics/FolderTrafficLightYellow80.png"
                    else if (segmentTrafficLightGrid.currentIndex == 2) iconTrafficLightPreviewImage.source = "pics/FolderTrafficLightRed80.png"
                }

                Component {
                    id: segmentTrafficLightCellDelegate

                    Item {
                        id: segmentTrafficLightCellDelegateItem
                        width: segmentTrafficLightGrid.cellWidth; height: segmentTrafficLightGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentTrafficLightGrid.currentIndex = index;
                                repeaterTrafficLightSegmentSelected = index;

                                updateFolderTrafficLightString();
                            }
                        }

                        Column {
                            id: segmentTrafficLightCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentTrafficLightGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconTrafficLightPreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 36
        height: 110
        color:  "#55000000"

        Image {
            id: iconTrafficLightPreviewImage
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

    }

    //
    // activity segment control
    //

    Item {
        id: repeatSegmentActivityControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 170
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: "Activity"
        }

        Rectangle {
            id: repeatSegmentActivityControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentActivityGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width /  model.count - 2; cellHeight: parent.height - 4

                model: segmentActivityModel
                delegate: segmentActivityCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true

                onVisibleChanged: {
                    if (visible) {
                        segmentActivityGrid.currentIndex = repeaterActivitySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")

                    if (segmentActivityGrid.currentIndex == 0) iconActivityPreviewImage.source = "pics/FolderRunstatusActive80.png"
                    else if (segmentActivityGrid.currentIndex == 1) iconActivityPreviewImage.source = "pics/FolderRunstatusPause80.png"
                    else if (segmentActivityGrid.currentIndex == 2) iconActivityPreviewImage.source = "pics/FolderRunstatusStopped80.png"
                    else if (segmentActivityGrid.currentIndex == 3) iconActivityPreviewImage.source = "pics/FolderRunstatusCompleted80.png"
                }

                Component {
                    id: segmentActivityCellDelegate

                    Item {
                        id: segmentActivityCellDelegateItem
                        width: segmentActivityGrid.cellWidth; height: segmentActivityGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentActivityGrid.currentIndex = index;
                                repeaterActivitySegmentSelected = index;

                                updateFolderActivityString();
                            }
                        }

                        Column {
                            id: segmentActivityCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentActivityGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconActivityPreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 206
        height: 110
        color:  "#55000000"

        Image {
            id: iconActivityPreviewImage
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

    }


}
